/**/
Call RxFuncAdd 'DW_LoadFuncs', 'rexxdw', 'DW_LoadFuncs'
Call dw_loadfuncs

Trace o
/*
 * Depending on platform, set up various constants
 */
Parse Version ver
Parse Source os . prog
Say os prog ver
lp = Lastpos( !REXXDW.!DIRSEP, prog )
icondir = Substr( prog, 1, lp )
Select
   When os = 'OS2' Then
      Do
         !global.!fixedfont = "10.System VIO"
         !global.!icondir = icondir'os2\'
         rexxutil = 'regutil'
         !global.!root = 'c:\rexxdw'
      End
   When os = 'OS/2' Then
      Do
         !global.!fixedfont = "10.System VIO"
         !global.!icondir = icondir'os2\'
         rexxutil = 'REXXUTIL'
         !global.!root = 'c:\rexxdw'
      End
   When os = 'WIN32' | os = 'WindowsNT' Then
      Do
         !global.!fixedfont = "20.Terminal"
         !global.!icondir = icondir'win\'
         rexxutil = 'rexxutil'
         !global.!root = 'd:\rexxdw'
      End
   When !REXXDW.!GTK_MAJOR_VERSION > 1 Then
      Do
         !global.!fixedfont = "monospace 20"
         !global.!icondir = icondir'gtk/'
         rexxutil = 'rexxutil'
         !global.!root = '/home/mark/RexxDW'
      End
   Otherwise
      Do
         !global.!fixedfont = "fixed"
         !global.!icondir = icondir'gtk/'
         rexxutil = 'rexxutil'
         !global.!root = '/home/mark/RexxDW'
      End
End

If RxFuncQuery( 'sysstemsort' ) \= 0 Then
   Do
      If RxFuncAdd( 'sysloadfuncs', rexxutil, 'sysloadfuncs' ) \= 0 Then
         Do
            If RxFuncAdd( 'SysLoadFuncs', rexxutil, 'SysLoadFuncs' ) \= 0 Then
               Do
                  Say 'Could not load' rexxutil'. Aborting'
                  Exit 1
               End
         End
   End
Call SysLoadFuncs

!globalv = '!REXXDW. !global.'

font_width = 8
font_height=12
rows=100
width1=6
cols=80
num_lines=0
max_linewidth=0
current_row=0
current_col=0
scrollbarwidth = 14
current_file = ''

numeric digits 12

!global.!days.1 = 'Monday:'
!global.!days.2 = 'Tuesday:'
!global.!days.3 = 'Wednesday:'
!global.!days.4 = 'Thursday:'
!global.!days.0 = 4

!global.!langs.1 = 'Rexx:'
!global.!langs.2 = 'COBOL:'
!global.!langs.3 = 'PL/1:'
!global.!langs.0 = 3

Call dw_init

!global.!allowcallbacks = 0

!global.!screen_width = dw_screen_width()
!global.!screen_height = dw_screen_height()

!global.!foldericon = dw_icon_load_from_file( !global.!icondir'folder' );
!global.!fileicon = dw_icon_load_from_file( !global.!icondir'file'  );

!global.!style = dw_or( !REXXDW.!DW_FCF_SYSMENU, !REXXDW.!DW_FCF_TITLEBAR, !REXXDW.!DW_FCF_SHELLPOSITION, !REXXDW.!DW_FCF_TASKLIST, !REXXDW.!DW_FCF_DLGBORDER )
/* create our toplevel window */
!global.!mainwindow = dw_window_new( !REXXDW.!DW_DESKTOP, 'Rexx/DW Test', dw_or( !global.!style, !REXXDW.!DW_FCF_SIZEBORDER, !REXXDW.!DW_FCF_MINMAX ) )

notebookbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start !global.!mainwindow, notebookbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

notebook = dw_notebook_new( 0, !REXXDW.!DW_TAB_TO_TOP )
Call dw_box_pack_start notebookbox, notebook, 100, 100, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

/*
 * Various:
 *   box, groupbox, button, bitmapbutton, slider/percent, radiobutton/checkbutton
 * Container: (explorer)
 *   container, tree, popup menu, splitbar, mle
 * Render: (display file selected in Container)
 *   render, pixmap
pages = 'Various Explorer Rendering MDI Dialog Utility Box'
 */
pages = 'Various Explorer MDI Dialog Utility Box'
Do i = 1 To Words( pages )
   Call CreatePage notebook, Word( pages, i ), i
End

Call dw_notebook_page_set notebook, !global.!notebookpage.1
Call dw_signal_connect !global.!mainwindow, !REXXDW.!DW_DELETE_EVENT, 'QuitCallback', !global.!mainwindow

/* add a menubar to the toplevel window */
mainmenubar = dw_menubar_new( !global.!mainwindow )
/* add menus to the menubar */
menu = dw_menu_new( 0 )
menuitem = dw_menu_append_item( menu, 'Browse ~Directory', 1011, 0, !REXXDW.!DW_MENU_END, !REXXDW.!DW_MENU_NOT_CHECKABLE, 0 )
Call dw_signal_connect menuitem, !REXXDW.!DW_CLICKED_EVENT, 'BrowseCallback', 'dir'
menuitem = dw_menu_append_item( menu, 'Browse ~File', 1012, 0, !REXXDW.!DW_MENU_END, !REXXDW.!DW_MENU_NOT_CHECKABLE, 0 )
Call dw_signal_connect menuitem, !REXXDW.!DW_CLICKED_EVENT, 'BrowseCallback', 'file'
menuitem = dw_menu_append_item( menu, '~About', 1013, 0, !REXXDW.!DW_MENU_END, !REXXDW.!DW_MENU_NOT_CHECKABLE, 0 )
Call dw_signal_connect menuitem, !REXXDW.!DW_CLICKED_EVENT, 'HelpAboutCallback'
menuitem = dw_menu_append_item( menu, '~Quit', 1020, 0, !REXXDW.!DW_MENU_END, !REXXDW.!DW_MENU_NOT_CHECKABLE, 0 )
Call dw_signal_connect menuitem, !REXXDW.!DW_CLICKED_EVENT, 'QuitCallback', !global.!mainwindow
/*
 * Add the 'File' menu to the menubar...
 */
Call dw_menu_append_item mainmenubar, '~File', 1010, 0, !REXXDW.!DW_MENU_END, !REXXDW.!DW_MENU_NOT_CHECKABLE, menu
/*
timerid = dw_timer_connect( 1000, 'timer_callback' )
*/
Call dw_window_set_pos_size !global.!mainwindow, 0, 0, 750, 650
Call dw_window_show !global.!mainwindow
/*
 * The following is the main event loop for this program. We check the
 * variable !REXXDW.!HAVE_REXXCALLBACK to determine which mechanism
 * can be used for callbacks. It is far better to use the mechanism
 * offered by an interpreter that offers RexxCallBack() in its API.
 */

!global.!allowcallbacks = 1

If !REXXDW.!HAVE_REXXCALLBACK Then
   Do
      Call dw_main
   End
Else
   Do Forever
      cmd = dw_main_iteration()
      If cmd \= '' Then
         Do
            Interpret 'Call' cmd
         End
   End

Return 0

CreatePage: Procedure Expose (!globalv)
Parse Arg notebook, page, idx
func = Translate( page, '', '/' )
!global.!notebookbox.idx = dw_box_new( !REXXDW.!DW_VERT )
!global.!notebookpage.idx = dw_notebook_page_new( notebook, 0, !REXXDW.!DW_PAGE_TO_BACK )
Call dw_notebook_pack notebook, !global.!notebookpage.idx, !global.!notebookbox.idx
Call dw_notebook_page_set_text notebook, !global.!notebookpage.idx, page
Interpret 'Call' func idx
Return

GenericClickCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg ., text
Parse Value dw_window_get_pos_size( !global.!mainwindow ) With x y width height
Call dw_messagebox 'Rexx/DW Test', !REXXDW.!DW_MB_OK, text x y width height
Return 0

EntryClickCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg ., slider, spinbutton, entry, password, combo, listbox
text = dw_slider_get_pos( slider )
Call dw_window_set_text !global.!slider_text, 'Slider:' text
text = dw_spinbutton_get_pos( spinbutton )
Call dw_window_set_text !global.!spinbutton_text, 'Spinbutton:' text
text = dw_window_get_text( entry )
Call dw_window_set_text !global.!entry_text, 'EntryField:' text
text = dw_window_get_text( password )
Call dw_window_set_text !global.!password_text, 'Password:' text
text = dw_window_get_text( combo )
Call dw_window_set_text !global.!combo_text, 'Combobox:' text
idx = dw_listbox_selected( listbox )
If idx = -1 Then Call dw_window_set_text !global.!listbox_text, 'Listbox: *none selected*'
Else
   Do
      text = dw_listbox_get_text( listbox, idx )
      Call dw_window_set_text !global.!listbox_text, 'Listbox:' text
   End
Return 0

CheckClickCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Do i = 1 To !global.!days.0
   If dw_radiobutton_get( !global.!days_cb.i ) Then text = !global.!days.i 'Yes'
   Else text = !global.!days.i 'No'
   Call dw_window_set_text !global.!days_text.i, text
End
Do i = 1 To !global.!langs.0
   If dw_checkbox_get( !global.!langs_cb.i ) Then text = !global.!langs.i 'Yes'
   Else text = !global.!langs.i 'No'
   Call dw_window_set_text !global.!langs_text.i, text
End
Return 0

SliderCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg win, value, percent, spinbutton
Call dw_percent_set_pos percent, value
Call dw_spinbutton_set_pos spinbutton, value
Return 0

SpinbuttonCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg win, value, percent, slider
Call dw_percent_set_pos percent, value
Call dw_slider_set_pos slider, value
Return 0

BrowseCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Upper Arg ., type
title.DIR = 'Directory'
title.FILE = 'File'
flag.DIR = !REXXDW.!DW_DIRECTORY_OPEN
flag.FILE = !REXXDW.!DW_FILE_OPEN
/* dw_file_browse() on at least Windows changes directory! */
here = Directory()
ret = Strip( dw_file_browse( 'Select' title.type, '', , flag.type ) )
If ret \= '' Then Call dw_messagebox title.type 'selected', !REXXDW.!DW_MB_OK, 'The' title.type 'selected was' ret
Else Call dw_messagebox title.type 'Selected', !REXXDW.!DW_MB_OK, 'The' title.type 'selection was cancelled'
Call Directory here
Return 0

/* sets the window data entry for 'myvalue' */
SetWindowDataCallback:
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg ., entry
Call dw_window_set_data entry, 'myvalue', dw_window_get_text( entry )
Return 0

/* gets the window data entry for 'myvalue' */
GetWindowDataCallback:
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg ., entry, text
Call dw_window_set_text text, 'Window Data:' dw_window_get_data( entry, 'myvalue' )
Return 0

/* the help about callback */
HelpAboutCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
window_x = 500
window_y = 180
splashwindow = dw_window_new( !REXXDW.!DW_DESKTOP, 'Rexx/DW Details', !global.!style )
/*Call dw_window_set_icon splashwindow, ?qocca.?qoccaicon*/
textbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start splashwindow, textbox, window_x-64, window_y-45, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_window_set_color textbox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE
/*
 * Display version details
 */
Parse Version ver
t1  = dw_text_new( 'Rexx Version:' ver, 0 )
Call dw_box_pack_start textbox, t1, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_window_set_style t1, dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER) , dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER )
Call dw_window_set_color t1, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE

t1  = dw_text_new( 'RexxDW Version:' dw_variable( 'VERSION' ), 0 )
Call dw_box_pack_start textbox, t1, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_window_set_style t1, dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER) , dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER )
Call dw_window_set_color t1, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE

Call dw_environment_query 'ver.'

t1 = dw_text_new( 'dwindows Version:' ver.8'.'ver.9'.'ver.10 'Built:' ver.2 ver.3, 0 )
Call dw_box_pack_start textbox, t1, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_window_set_style t1, dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER) , dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER )
Call dw_window_set_color t1, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE

t1 = dw_text_new( 'Operating System:' ver.1 '('ver.4'.'ver.5')', 0 )
Call dw_box_pack_start textbox, t1, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_window_set_style t1, dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER) , dw_or( !REXXDW.!DW_DT_CENTER, !REXXDW.!DW_DT_VCENTER )
Call dw_window_set_color t1, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE
/*
 * Our OK button
 */
abutton = dw_button_new( 'OK', 0 )
Call dw_box_pack_start textbox, abutton, window_x, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 1
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'GenericCloseCallback', splashwindow
Call dw_signal_connect splashwindow, !REXXDW.!DW_DELETE_EVENT, 'GenericCloseCallback', splashwindow
/*
 * Display the splash window
 */
Call dw_window_set_pos_size splashwindow, (!global.!screen_width % 2) - (window_x % 2), (!global.!screen_height % 2) - (window_y % 2), window_x, window_y
Call dw_window_show splashwindow
Return 0

/* called when a key is pressed */
KeyPressCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg window, key, virtual_key, state, where, textwin
Select
   When where = 'pointer_pos' Then
      Do
         Select
            When virtual_key = !REXXDW.!DW_VK_F1 Then
               Do
                  Parse Value dw_pointer_get_pos() With x y
                  Call dw_window_set_text textwin, 'Pointer at:' x'/'y
               End
            When virtual_key = !REXXDW.!DW_VK_F2 Then
               Do
                  Parse Value dw_pointer_get_pos() With x y
                  Call dw_pointer_set_pos 0, 0
                  Call dw_window_set_text textwin, 'Pointer moved from:' x'/'y 'to: 0/0'
               End
            When virtual_key = !REXXDW.!DW_VK_F3 Then
               Do
                  Parse Value dw_window_get_pos_size( window ) With wx wy .
                  Parse Value dw_pointer_get_pos() With x y
                  Call dw_pointer_set_pos x-wx, y-wy
                  Call dw_window_set_text textwin, 'Pointer moved from:' x'/'y 'to window: 0/0'
               End
            Otherwise Nop
         End
      End
   Otherwise Nop
End
Return 0

/* called when a mouse button is pressed */
ButtonPressCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg window, x, y, button, where, textwin
Select
   When where = 'pointer_pos' Then
      Do
         Select
            When button = 1 Then
               Do
                  Parse Value dw_pointer_get_pos() With x y
                  Call dw_window_set_text textwin, 'Pointer at:' x'/'y
               End
            When button = 2 Then
               Do
                  Parse Value dw_pointer_get_pos() With x y
                  Call dw_pointer_set_pos 0, 0
                  Call dw_window_set_text textwin, 'Pointer moved from:' x'/'y 'to: 0/0'
               End
            When button = 3 Then
               Do
                  Parse Value dw_window_get_pos_size( window ) With wx wy .
                  Parse Value dw_pointer_get_pos() With x y
                  Call dw_pointer_set_pos x-wx, y-wy
                  Call dw_window_set_text textwin, 'Pointer moved from:' x'/'y 'to window: 0/0'
               End
            Otherwise Nop
         End
      End
   Otherwise Nop
End
trace o
Return 0

GenericCloseCallback: Procedure Expose !REXXDW.
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg ., window, dialog
Call dw_window_destroy window
If dialog \= '' Then Call dw_dialog_dismiss dialog, 'close'
Return 0

QuitCallback:
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg win, mainwin
Call dw_window_destroy mainwin
Exit 0

/*
 * Each page showing different widgets...
 */
Various: Procedure Expose (!globalv)
Parse Arg idx
mainbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start !global.!notebookbox.idx, mainbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

/* first col - buttons */
buttonbox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Buttons' )
Call dw_box_pack_start mainbox, buttonbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

tmpbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start buttonbox, tmpbox, 150, 200, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
abutton = dw_button_new( 'A really big text button!', 0 )
Call dw_box_pack_start tmpbox, abutton, 150, 200, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'GenericClickCallback', 'A really big text button!'

/* enabled buttons */
tmpbox = dw_groupbox_new( !REXXDW.!DW_HORZ, 'Enabled Buttons' )
Call dw_box_pack_start buttonbox, tmpbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
abutton = dw_bitmapbutton_new_from_file( 'A file button', 0, !global.!icondir||'file' )
Call dw_box_pack_start tmpbox, abutton, 32, 32, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 2
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'GenericClickCallback', 'A file button'

abutton = dw_bitmapbutton_new_from_file( 'A dir button', 0, !global.!icondir||'folder' )
Call dw_box_pack_start tmpbox, abutton, 32, 32, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 2
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'GenericClickCallback', 'A directory button'

/* disabled buttons */
tmpbox = dw_groupbox_new( !REXXDW.!DW_HORZ, 'Disabled Buttons' )
Call dw_box_pack_start buttonbox, tmpbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
abutton = dw_bitmapbutton_new_from_file( 'A file button', 0, !global.!icondir||'file' )
Call dw_box_pack_start tmpbox, abutton, 32, 32, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 2
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'GenericClickCallback', 'A file button'
Call dw_window_disable abutton

abutton = dw_bitmapbutton_new_from_file( 'A dir button', 0, !global.!icondir||'folder' )
Call dw_box_pack_start tmpbox, abutton, 32, 32, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 2
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'GenericClickCallback', 'A directory button'
Call dw_window_disable abutton

/* second col - entry */
secondbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start mainbox, secondbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

sliderbox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Slider/Percent' )
Call dw_box_pack_start secondbox, sliderbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

/* slider */
tmpbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start sliderbox, tmpbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
tmp = dw_text_new( 'Slider:', 0 )
Call dw_box_pack_start tmpbox, tmp, 100, 20, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
slider = dw_slider_new( !REXXDW.!DW_HORZ, 100, 0 )
Call dw_box_pack_start tmpbox, slider, 0, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

/* slider percent */
tmpbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start sliderbox, tmpbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
slider_percent = dw_percent_new( 0 )
Call dw_box_pack_start tmpbox, slider_percent, 0, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

Call dw_percent_set_pos slider_percent, 0

Call dw_box_pack_start sliderbox, 0, 200, 5, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

/* spinbutton */
tmp = dw_text_new( 'Spinbutton:', 0 )
Call dw_box_pack_start sliderbox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
spinbutton = dw_spinbutton_new( '', 0 )
Call dw_box_pack_start sliderbox, spinbutton, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_spinbutton_set_limits spinbutton, 100, 0
Call dw_spinbutton_set_pos spinbutton, 0
/*
 * As our slider and spinbutton are tied together, we need the widget id for each callback
 */
Call dw_signal_connect spinbutton, !REXXDW.!DW_VALUE_CHANGED_EVENT, 'SpinbuttonCallback', slider_percent, slider
Call dw_signal_connect slider, !REXXDW.!DW_VALUE_CHANGED_EVENT, 'SliderCallback', slider_percent, spinbutton

entrybox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Entry' )
Call dw_box_pack_start secondbox, entrybox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

tmp = dw_text_new( 'EntryField:', 0 )
Call dw_box_pack_start entrybox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
entry = dw_entryfield_new( '', 0 )
Call dw_box_pack_start entrybox, entry, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

tmp = dw_text_new( 'Password:', 0 )
Call dw_box_pack_start entrybox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
password = dw_entryfield_password_new( '', 0 )
Call dw_box_pack_start entrybox, password, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

tmp = dw_text_new( 'Combobox:', 0 )
Call dw_box_pack_start entrybox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
combo = dw_combobox_new( '', 0 )
Call dw_box_pack_start entrybox, combo, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_window_set_text combo, 'item 1'
Call dw_listbox_append combo, 'item 1'
Call dw_listbox_append combo, 'item 2'
Call dw_listbox_append combo, 'item 3'

tmp = dw_text_new( 'Listbox:', 0 )
Call dw_box_pack_start entrybox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
listbox = dw_listbox_new( 673, !REXXDW.!DW_LB_SINGLE_SELECTION )
Call dw_box_pack_start entrybox, listbox, 200, 40, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_listbox_append listbox, 'item 1'
Call dw_listbox_append listbox, 'item 2'
Call dw_listbox_append listbox, 'item 3'

Call dw_box_pack_start entrybox, 0, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

tmpbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start entrybox, tmpbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

Call dw_box_pack_start tmpbox, 0, 0, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
abutton = dw_button_new( 'Show Values', 0 )
Call dw_box_pack_start tmpbox, abutton, 100, 20, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'EntryClickCallback', slider, spinbutton, entry, password, combo, listbox
Call dw_box_pack_start tmpbox, 0, 0, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

/* display the current values */
!global.!slider_text = dw_text_new( 'Slider:', 0 )
Call dw_box_pack_start entrybox, !global.!slider_text, 200, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
!global.!spinbutton_text = dw_text_new( 'Spinbutton:', 0 )
Call dw_box_pack_start entrybox, !global.!spinbutton_text, 200, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
!global.!entry_text = dw_text_new( 'EntryField:', 0 )
Call dw_box_pack_start entrybox, !global.!entry_text, 200, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
!global.!password_text = dw_text_new( 'Password:', 0 )
Call dw_box_pack_start entrybox, !global.!password_text, 200, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
!global.!combo_text = dw_text_new( 'Combobox:', 0 )
Call dw_box_pack_start entrybox, !global.!combo_text, 200, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
!global.!listbox_text = dw_text_new( 'Listbox:', 0 )
Call dw_box_pack_start entrybox, !global.!listbox_text, 200, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

/* third col - radio/checkbox */
thirdbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start mainbox, thirdbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

radiocheckbox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Radio/Check Boxes' )
Call dw_box_pack_start thirdbox, radiocheckbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

radiobox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Favourite Language' )
Call dw_window_set_color radiobox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_CYAN
Call dw_box_pack_start radiocheckbox, radiobox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
Do i = 1 To !global.!langs.0
   !global.!langs_cb.i = dw_radiobutton_new( !global.!langs.i, 100+i )
   Call dw_box_pack_start radiobox, !global.!langs_cb.i, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
   Call dw_window_set_color !global.!langs_cb.i, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_CYAN
End
Call dw_radiobutton_set !global.!langs_cb.1, !REXXDW.!DW_CHECKED

checkbox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Staying Awake Days' )
Call dw_box_pack_start radiocheckbox, checkbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
Call dw_window_set_color checkbox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_YELLOW
Do i = 1 To !global.!days.0
   !global.!days_cb.i = dw_checkbox_new( !global.!days.i, 0 )
   Call dw_box_pack_start checkbox, !global.!days_cb.i, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
   Call dw_window_set_color !global.!days_cb.i, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_YELLOW
End

Call dw_box_pack_start radiocheckbox, 0, 0, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

tmpbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start radiocheckbox, tmpbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

Call dw_box_pack_start tmpbox, 0, 0, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
abutton = dw_button_new( 'Show Values', 0 )
Call dw_box_pack_start tmpbox, abutton, 100, 20, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'CheckClickCallback', entry, password, combo, listbox
Call dw_box_pack_start tmpbox, 0, 0, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

/* display the current values */

tmpbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start radiocheckbox, tmpbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

langbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start tmpbox, langbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

Call dw_window_set_color langbox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_CYAN
Do i = 1 To !global.!langs.0
   !global.!langs_text.i = dw_text_new( '', 0 )
   Call dw_box_pack_start langbox, !global.!langs_text.i, 0, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
   Call dw_window_set_color !global.!langs_text.i, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_CYAN
End

daysbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start tmpbox, daysbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5
Call dw_window_set_color daysbox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_YELLOW
Do i = 1 To !global.!days.0
   !global.!days_text.i = dw_text_new( '', 0 )
   Call dw_box_pack_start daysbox, !global.!days_text.i, 0, 15, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
   Call dw_window_set_color !global.!days_text.i, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_YELLOW
End

Call CheckClickCallback
Return

Explorer: Procedure Expose (!globalv)
Parse Arg idx

flags.0 = 3
flags.1 = dw_or( !REXXDW.!DW_CFA_STRING, !REXXDW.!DW_CFA_CENTER, !REXXDW.!DW_CFA_SEPARATOR, !REXXDW.!DW_CFA_HORZSEPARATOR )
flags.2 = dw_or( !REXXDW.!DW_CFA_ULONG, !REXXDW.!DW_CFA_RIGHT, !REXXDW.!DW_CFA_SEPARATOR, !REXXDW.!DW_CFA_HORZSEPARATOR )
flags.3 = dw_or( !REXXDW.!DW_CFA_STRING, !REXXDW.!DW_CFA_LEFT, !REXXDW.!DW_CFA_SEPARATOR, !REXXDW.!DW_CFA_HORZSEPARATOR )
titles.0 = 3
titles.1 = 'File Date'
titles.2 = 'Size'
titles.3 = 'Permissions'
mainbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start !global.!notebookbox.idx, mainbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

treecontainerbox = dw_box_new( !REXXDW.!DW_HORZ ) /* don't pack */
treebox = dw_box_new( !REXXDW.!DW_HORZ ) /* don't pack */
containerbox = dw_box_new( !REXXDW.!DW_HORZ ) /* don't pack */
mlebox = dw_box_new( !REXXDW.!DW_HORZ ) /* don't pack */

hsplitbar = dw_splitbar_new( !REXXDW.!DW_HORZ, treebox, containerbox, 0 )
Call dw_box_pack_start treecontainerbox, hsplitbar, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_splitbar_set hsplitbar, 30.0

vsplitbar = dw_splitbar_new( !REXXDW.!DW_VERT, treecontainerbox, mlebox, 0 )
Call dw_box_pack_start mainbox, vsplitbar, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_splitbar_set vsplitbar, 50.0

!global.!tree = dw_tree_new( 101 )
Call dw_box_pack_start treebox, !global.!tree, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

!global.!container = dw_container_new( 100, !REXXDW.!DW_SINGLE_SELECTION )
Call dw_box_pack_start containerbox, !global.!container, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0

Call dw_filesystem_setup !global.!container, 'flags.', 'titles.'

Call PopulateTree !global.!root
/*
Call dw_tree_item_select !global.!tree, !global.!toptreeitem
*/

!global.!mle = dw_mle_new( 0 )
Call dw_box_pack_start mlebox, !global.!mle, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_mle_set_word_wrap !global.!mle, !REXXDW.!DW_DONT_WORD_WRAP
Call dw_window_set_color !global.!mle, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE

Return

PopulateTree: Procedure Expose (!globalv)
Parse Arg dir
/*
thisdir = Stream( Strip( dir, 'T', '/' ), 'C', 'QUERY EXISTS' ) || !REXXDW.!DIRSEP
*/
olddir = Directory( )
Call Directory  dir
thisdir = Directory() || !REXXDW.!DIRSEP
Call Directory olddir
!global.!allowcallbacks = 0
Call dw_signal_connect !global.!tree, !REXXDW.!DW_ITEM_SELECT_EVENT, 'TreeSelectCallback'
/*
 * Populate our tree with files from specified directory
 * Need rexxutil
 */
Call SysFileTree thisdir'*', 'DIR.', 'ODS' /**/
Call SysStemSort 'DIR.', 'Ascending', , , , 1, 100
!global.!toptreeitem = dw_tree_insert( !global.!tree, '['thisdir']', !global.!foldericon, 0, '.' )
Do i = 1 To dir.0
   mydir = dir.i
   pos = Lastpos( !REXXDW.!DIRSEP, mydir )
   currentdir = Substr( mydir, pos+1 )
   parent = Substr( mydir, 1, pos-1 )
   parentidx = FindTreeItem( parent )
   If parentidx = 0 Then parentitem = !global.!toptreeitem
   Else parentitem = !global.!treeitem.parentidx
   !global.!treeitem.i = dw_tree_insert( !global.!tree, currentdir, !global.!foldericon, parentitem, dir.i )
End
!global.!allowcallbacks = 1
Return

PopulateContainer: Procedure Expose (!globalv)
Parse Arg dir
/*
thisdir = Stream( Strip( dir, 'T', '/' ), 'C', 'QUERY EXISTS' ) || !REXXDW.!DIRSEP
*/
thisdir = dir
!global.!allowcallbacks = 0
/*
 * If this is NOT the first time we call this, we need to clear the contents
 * of the container
 */
If Left( !global.!container, 1 ) \= '!' Then
   Do
      /*
       * Clear our signals for container
       */
      Call dw_signal_disconnect !global.!container, !REXXDW.!DW_ITEM_SELECT_EVENT
      Call dw_container_clear !global.!container, !REXXDW.!DW_DONT_REDRAW
   End
/*
 * Get the files and directories for the specified directory
 */
Call SysFileTree thisdir||!REXXDW.!DIRSEP'*', '!GLOBAL.!FILE.', 'LF' /**/
Call SysStemSort '!GLOBAL.!FILE.', 'Ascending', , , , 40, 100
/*
 * We know how many items to go into our container; allocate memory for it
 */
containermemory = dw_container_alloc( !global.!container, !global.!file.0 )
Do i = 1 To !global.!file.0
   fn = SubWord( !global.!file.i, 5 )
   pos = Lastpos( !REXXDW.!DIRSEP, fn )
   fn = Substr( fn, pos+1 )
   Call dw_filesystem_set_file !global.!container, containermemory, i-1, fn, !global.!fileicon
   Call dw_filesystem_set_item !global.!container, containermemory, 0, i-1, Subword( !global.!file.i, 1, 2 )
   Call dw_filesystem_set_item !global.!container, containermemory, 1, i-1, Word( !global.!file.i, 3 )
   Call dw_filesystem_set_item !global.!container, containermemory, 2, i-1, Word( !global.!file.i, 4 )
   Call dw_container_set_row_title containermemory, i-1, i
End
Call dw_container_insert !global.!container, containermemory, !global.!file.0
Call dw_container_optimize !global.!container
/*
 * Connect our signals for the container AFTER populating it
 */
Call dw_signal_connect !global.!container, !REXXDW.!DW_ITEM_SELECT_EVENT, 'ContainerSelectCallback'
!global.!allowcallbacks = 1
Return

/*
 * Determine the index of the supplied directory in the list of directories
 * in the repository
 */
FindTreeItem: Procedure Expose (!globalv) dir.
Parse Arg item
Do i = 1 To dir.0
   If dir.i = item Then Return i
End
Return 0

/*
 * The callback for left mouse button click on Tree item
 */
TreeSelectCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg win, item, text, itemdata, userdata
If !global.!allowcallbacks = 1 Then Call PopulateContainer itemdata

Return 1

/*
 * The callback for left mouse button click on Container item
 */
ContainerSelectCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg win, item, text, itemdata, userdata
Call dw_mle_delete !global.!mle
/*
 * Get the file name from the file array...
 */
fn = SubWord( !global.!file.text, 5 )
/*
 * ...and check if it is a binary file...
 */
If IsBinaryFile( fn ) Then
   Do
      Call dw_messagebox 'Binary file!', dw_or( !REXXDW.!DW_MB_OK, !REXXDW.!DW_MB_WARNING ), fn 'is a binary file. Not displayed.'
      Return 1
   End
/*
 * ... and read it into the MLE
 */
Call dw_mle_freeze !global.!mle
crlf = d2c(13)||d2c(10)
Call Stream fn, 'C', 'OPEN READ'
pos = -1
Do While Lines( fn ) > 0
   line = Linein( fn )
   pos = dw_mle_import( !global.!mle, line||crlf, pos )
End
Call Stream fn, 'C', 'CLOSE'
Call dw_mle_thaw !global.!mle
Return 1

Rendering: Procedure Expose (!globalv) pixmap renderbox
Parse Arg idx
depth = dw_color_depth_get()
pagebox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start !global.!notebookbox.idx, pagebox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
/* create render box for our pixmap */
renderbox = dw_render_new( 0 )
Call dw_box_pack_start pagebox, renderbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
Call dw_window_set_font renderbox, !global.!fixedfont

/*
 * Why are these the same ????
 */
Parse Value dw_window_get_pos_size( renderbox ) With x y width height
Parse Value dw_window_get_pos_size( !global.!mainwindow ) With x y width height

pixmap = dw_pixmap_new( renderbox, width, height, depth )

Call DrawPixmap renderbox, pixmap

Call dw_signal_connect renderbox, !REXXDW.!DW_EXPOSE_EVENT, 'ExposeCallback', pixmap
Call dw_signal_connect renderbox, !REXXDW.!DW_CONFIGURE_EVENT, 'ConfigureCallback', pixmap
Return

ExposeCallback:
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg renderbox, x, y, width, height, pixmap
If renderbox \= '' Then
   Do
      width = dw_pixmap_width( pixmap )
      height = dw_pixmap_height( pixmap )
      Call dw_pixmap_bitblt renderbox, , 0, 0, width, height, , pixmap, 0, 0
      Call dw_flush
   End
Return 1

ConfigureCallback: Procedure Expose (!globalv)
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg renderbox, width, height, pixmap
/* Destroy the old pixmap */
Call dw_pixmap_destroy pixmap
depth = dw_color_depth_get()

/* Create new pixmap with the current size */
pixmap = dw_pixmap_new( renderbox, width, height, depth )

/* Redraw the window */
Call DrawPixmap renderbox, pixmap
return 1

DrawPixmap: Procedure Expose (!globalv)
Parse Arg renderbox, pixmap
width = dw_pixmap_width( pixmap )
height = dw_pixmap_height( pixmap )
Call dw_color_foreground_set !REXXDW.!DW_CLR_RED
Call dw_draw_rect , pixmap, !REXXDW.!DW_FILL, 10, 10, width - 20, height - 20
Call dw_color_foreground_set !REXXDW.!DW_CLR_BLUE
Call dw_color_background_set !REXXDW.!DW_CLR_RED
Call dw_draw_line , pixmap, 50, 50, width - 50, height - 50
Call dw_draw_line , pixmap, width - 50, 50, 50, height - 50
Call dw_draw_line , pixmap, width % 2, 50, width % 2, height - 50
Call dw_draw_line , pixmap, 50, height % 2, width - 50, height % 2
Parse Value dw_font_text_extents_get( renderbox, , "(g" ) With font_width font_height
font_width = font_width % 2
str = ' Some rendered text '
len = Length( str )
str_width = len * font_width
x = (width % 2) - (str_width % 2)
y = (height % 2) - (font_height % 2)
Call dw_draw_text , pixmap, x, y, str
Call ExposeCallback renderbox
Return

MDI: Procedure Expose (!globalv)
Parse Arg idx
/* create a box to pack into the notebook page */
mdibox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start !global.!notebookbox.idx, mdibox, 500, 200, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 1

/* now a mdi under this box */
mdi = dw_mdi_new(333)
Call dw_box_pack_start  mdibox, mdi, 500, 200, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

mdi1w = dw_window_new( mdi, 'MDI1', dw_or( !global.!style, !REXXDW.!DW_FCF_SIZEBORDER, !REXXDW.!DW_FCF_MINMAX ) )
mdi1box = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start  mdi1w, mdi1box, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
ef = dw_entryfield_new( "", 0)
Call dw_box_pack_start mdi1box, ef, 100, 15, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 4
Call dw_window_set_pos_size mdi1w, 10, 10, 200, 100
Call dw_window_show mdi1w

mdi2w = dw_window_new( mdi, 'MDI2', dw_or( !global.!style, !REXXDW.!DW_FCF_SIZEBORDER, !REXXDW.!DW_FCF_MINMAX ) )
mdi2box = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start  mdi2w, mdi2box, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
ef = dw_entryfield_new( "", 0)
Call dw_box_pack_start mdi2box, ef, 150, 30, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 4
bb = dw_button_new( "Browse", 0 )
Call dw_box_pack_start mdi2box, bb, 60, 30, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 4
Call dw_window_set_pos_size mdi2w, 150, 10, 300, 100
Call dw_window_show mdi2w
Return 0

Dialog: Procedure Expose (!globalv)
Return

/*
 * dw_screen_height(), dw_screen_width()
 * dw_window_set_data(), dw_window_get_data()
 * dw_pointer_get_pos(), dw_pointer_set_pos() (keyboard)
 */
Utility: Procedure Expose (!globalv)
Parse Arg idx
mainbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start !global.!notebookbox.idx, mainbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

/* first col - pointer position stuff */
firstbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start mainbox, firstbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
posbox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Position Info' )
Call dw_box_pack_start firstbox, posbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
tmp = dw_text_new( 'Screen Width:' dw_screen_width(), 0 )
Call dw_box_pack_start posbox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
tmp = dw_text_new( 'Screen Height:' dw_screen_height(), 0 )
Call dw_box_pack_start posbox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
tmp = dw_text_new( 'Press F1 or button 1 to display pointer position.', 0 )
Call dw_box_pack_start posbox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
tmp = dw_text_new( 'Press F2 or button 2 to move pointer to screen 0/0.', 0 )
Call dw_box_pack_start posbox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
tmp = dw_text_new( 'Press F3 or button 3 to move pointer to window 0/0.', 0 )
Call dw_box_pack_start posbox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

/*
whitebox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start posbox, whitebox, 200, 200, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_window_set_color whitebox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE
*/
whitebox = dw_render_new( 0 )
Call dw_box_pack_start posbox, whitebox, 200, 200, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_color_background_set !REXXDW.!DW_CLR_WHITE
Call dw_draw_rect whitebox, , !REXXDW.!DW_FILL, 0, 0, 200, 200
Call dw_color_foreground_set !REXXDW.!DW_CLR_BLACK
Call dw_draw_rect whitebox, , !REXXDW.!DW_DONT_FILL, 0, 0, 200, 200

Parse Value dw_pointer_get_pos() With x y
mousepostext = dw_text_new( 'Mouse Position:' x'/'y, 0 )
Call dw_box_pack_start posbox, mousepostext, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
/*
Call dw_signal_connect whitebox, !REXXDW.!DW_KEY_PRESS_EVENT, 'KeyPressCallback', 'pointer_pos', mousepostext
*/
Call dw_signal_connect whitebox, !REXXDW.!DW_BUTTON_PRESS_EVENT, 'ButtonPressCallback', 'pointer_pos', mousepostext
Call dw_signal_connect !global.!mainwindow, !REXXDW.!DW_KEY_PRESS_EVENT, 'KeyPressCallback', 'pointer_pos', mousepostext
Call dw_signal_connect !global.!mainwindow, !REXXDW.!DW_BUTTON_PRESS_EVENT, 'ButtonPressCallback', 'pointer_pos', mousepostext


/* second col - dw_window_get/set_data() test */
secondbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start mainbox, secondbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 0
entrybox = dw_groupbox_new( !REXXDW.!DW_VERT, 'Window Data Test' )
Call dw_box_pack_start secondbox, entrybox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

tmp = dw_text_new( 'Enter Window Data:', 0 )
Call dw_box_pack_start entrybox, tmp, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
entry = dw_entryfield_new( '', 0 )
Call dw_box_pack_start entrybox, entry, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

abutton = dw_button_new( "Set Value", 0 )
Call dw_box_pack_start entrybox, abutton, 30, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'SetWindowDataCallback', entry

text = dw_text_new( 'Window Data:', 0 )
Call dw_box_pack_start entrybox, text, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0

abutton = dw_button_new( "Get Value", 0 )
Call dw_box_pack_start entrybox, abutton, 30, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 0
Call dw_signal_connect abutton, !REXXDW.!DW_CLICKED_EVENT, 'GetWindowDataCallback', entry, text

Return

Box: Procedure Expose (!globalv)
Parse Arg idx
topbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start !global.!notebookbox.idx, topbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

/* create our RED HORZ box and pack it into the top box */
box1 = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start topbox, box1, 500, 200, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5
Call dw_window_set_color box1, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_RED

/* create a legend VERT box and pack it into the top box */
box2 = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start topbox, box2, 250, 200, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

/* create our BLUE VERT box on the left and pack it into the RED box */
leftbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start box1, leftbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 10
Call dw_window_set_color leftbox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_BLUE
/* add 4 entryfields */
Do i = 1 To 4
   entry = dw_entryfield_new( '', 0 )
   Call dw_box_pack_start leftbox, entry, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 5
End

/* create our BLUE VERT box on the right and pack it into the RED box */
rightbox = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start box1, rightbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 10
Call dw_window_set_color rightbox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_BLUE
/* add 2 entryfields */
Do i = 1 To 2
   entry = dw_entryfield_new( '', 0 )
   Call dw_box_pack_start rightbox, entry, 200, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_DONT_EXPAND_VERT, 5
End
/* now another RED HORZ box for a couple of buttons */
smallbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start rightbox, smallbox, 0, 0, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5
Call dw_window_set_color smallbox, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_RED
abutton = dw_button_new( 'OK', 0 )
Call dw_box_pack_start smallbox, abutton, 20, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5
abutton = dw_button_new( 'OK', 0 )
Call dw_box_pack_start smallbox, abutton, 20, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5

/* now the legend boxes */
vertbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start box2, vertbox, 200, 0, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5
vertbox1 = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start vertbox, vertbox1, 50, 0, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 10
Call dw_window_set_color vertbox1, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_BLUE
stext = dw_text_new( "Vert Box", 0 )
Call dw_window_set_style stext, !REXXDW.!DW_DT_VCENTER, !REXXDW.!DW_DT_VCENTER
Call dw_box_pack_start vertbox1, stext, 50, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

vertbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start box2, vertbox, 200, 0, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5
vertbox2 = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start vertbox, vertbox2, 50, 0, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 10
Call dw_window_set_color vertbox2, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_RED
stext = dw_text_new( "Horz Box", 0 )
Call dw_window_set_style stext, !REXXDW.!DW_DT_VCENTER, !REXXDW.!DW_DT_VCENTER
Call dw_box_pack_start vertbox2, stext, 50, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2

vertbox = dw_box_new( !REXXDW.!DW_HORZ )
Call dw_box_pack_start box2, vertbox, 200, 0, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 5
vertbox3 = dw_box_new( !REXXDW.!DW_VERT )
Call dw_box_pack_start vertbox, vertbox3, 50, 0, !REXXDW.!DW_DONT_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 10
Call dw_window_set_color vertbox3, !REXXDW.!DW_CLR_BLACK, !REXXDW.!DW_CLR_WHITE
stext = dw_text_new( "Widget", 0 )
Call dw_window_set_style stext, !REXXDW.!DW_DT_VCENTER, !REXXDW.!DW_DT_VCENTER
Call dw_box_pack_start vertbox3, stext, 50, 20, !REXXDW.!DW_EXPAND_HORZ, !REXXDW.!DW_EXPAND_VERT, 2
Return

timer_callback:
If !global.!allowcallbacks = 0 Then Return 1
Call dw_beep 200, 200
If \!REXXDW.!HAVE_REXXCALLBACK Then timerid = dw_timer_connect( 1000, 'timer_callback' )
/* return 1 here to ensure that timer is re-armed */
Return 1

beep_callback:
If !global.!allowcallbacks = 0 Then Return 1
Call dw_timer_disconnect timerid
Return 1

text_expose_callback:
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg win, x, y, width, height, data
If win = textbox1 Then hpm = text1pm
Else hpm = text2pm
width = dw_pixmap_width(hpm)
height = dw_pixmap_height(hpm)

Call dw_pixmap_bitblt win, , 0, 0, width, height, , hpm, 0, 0
Call dw_flush
return 1

scrollbar_valuechanged_callback:
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg hwnd, value, stext
If stext \= '' Then
   Do
      If hwnd = vscrollbar Then current_row = value
      Else current_col = value
      Call dw_window_set_text stext, 'Row:'current_row 'Col:'current_col 'Lines:'num_lines 'Cols:'max_linewidth
      Call draw_file  current_row, current_col
   End
Return 1

keypress_callback:
If !global.!allowcallbacks = 0 Then Return 1
Parse Arg win, char, virtualkey, state, data
return 1

/*
 * Tests if the given filename is binary; ie there is at least one
 * nul character in the first 1024 characters.
 */
IsBinaryFile: Procedure
Parse Arg fn
size = Stream( fn, 'C', 'QUERY SIZE' )
numchars = Min( size, 1024 )
Call Stream fn, 'C', 'OPEN READ'
file_block = Charin( fn, 1, numchars )
test_block = Translate( file_block, '#', '00'x )
If file_block \== test_block Then
   binary = 1
Else
   binary = 0
Call Stream fn, 'C', 'CLOSE'
Return binary
